/*
 
  LANChat Linux version 1.1.0 fully compatible with windows LC40
  Based on LC 4.0 specification by Piotr Kowalski <goro@vc.pl> 
  
  (c) Mateusz Skoczewski <melun@xox.pl>
  Antoby <antoby@mail.com>
  jeremian <jeremian@poczta.fm>
 
  ----------------------------------------------------------------------
  The Linux LANChat and related utilities are free software; you can
  redistribute it and/or modify it under the terms of the GNU Library
  general Public License as published by the Free Software Foundation;
  either version 2 of the License, or (at your option) any later version.
 
*/
#include "lanchat.h"

int iswithoutcomma(char* text) {
	int i = 0;
	int ok = 1;
	while (text[i] != '\0') {
		if (text[i] == ',') {
			ok = 0;
			break;
		}
		++i;
	}
	return ok;
}
	

void findword(void) {
	int i, j, ok, result, dif;
	int amount = 0;
	char name[20];
	for (i=0; i<18; ++i) {
		j=1;
		ok=1;
		while (readbuffer[j]!='\0') {
			if (readbuffer[j] != commands[i][j-1]) {
				ok = 0;
				break;
			}
			++j;
			if (j==9) {
				ok = 0;
				break;
			}
		}
		if (ok) {++amount;
			result = i;
		}
	}
	if (amount == 1) {
		memset(readbuffer, 0, 30);
		strcpy(readbuffer, "/");
		strcat(readbuffer, commands[result]);
		pom = strlen(readbuffer);
	}
	else {
		beep();
	}
	
	amount = 0;
	if (!cmp(readbuffer, "/pop ") || !cmp(readbuffer, "/msg ") || 
			!cmp(readbuffer, "/whois ")) {
if (readbuffer[1] == 'w') dif=7; else dif = 5;
		j = dif;
		while (readbuffer[j] != '\0') {
			name[j-dif] = readbuffer[j];
			++j;
			if (j==19+dif) break;
		}
		name[j-dif]='\0';

	for (i=0; i<255; ++i) {
		j=0;
		ok=1;
		while (name[j]!='\0') {
			if (name[j] != users[i].nick[j]) {
				ok = 0;
				break;
			}
			++j;
			if (j==9) {
				ok = 0;
				break;
			}
		}
		if (ok && j) {++amount;
			result = i;
		}
	}
	if (amount == 1) {
		memset(readbuffer+dif, 0, 20);
		strcat(readbuffer, users[result].nick);
		if (readbuffer[1] != 'w') strcat(readbuffer, ", ");
		pom = strlen(readbuffer);
	}
	else {
		beep();
	}
	}
	
}

void savingoptions(void) {
		pthread_mutex_lock( &writemutex);
	f = fopen(directory, "w");
	if (f) {
fprintf(f,"# This is a configuration file for lanchat\n\n");
fprintf(f,"# user login - must be >2 and <20, it's your logname by default\n");
fprintf(f,"!u %s\n", hsnd.nick);
fprintf(f,"# allowing pop-ups - could be 0 or 1, it's 0 (ON) by default\n");
fprintf(f,"!p %d\n", pop_mode);
fprintf(f,"# logging to a file - could be 0 or 1, it's 1 (ON) by default\n");
fprintf(f,"!l %d\n", writeus);
fprintf(f,"# size of commands history buffer (10-500), it's 20 by default\n");
fprintf(f,"!c %d\n", chist);
fprintf(f,"# size of messages history buffer (50-1000), it's 100 by default\n");
fprintf(f,"!m %d\n", mhist);
fprintf(f,"# user's colors: red, green and blue (not visible in this lc)\n");
fprintf(f,"# these values can be from 1 to 200. Default: r=100, g=50, b=200\n");
fprintf(f,"!r %d\n", col_r);
fprintf(f,"!g %d\n", col_g);
fprintf(f,"!b %d\n", col_b);
	fclose(f);
	}
		pthread_mutex_unlock( &writemutex);
}

void sleeping(int sig)
{
	sleep(5);
}

void usage(void)
{
    printf("Usage: LANChat [nickname] [-h host]\n\n");
    exit(1);
}

void cleanup(void)
{
    standend();
    curs_set(1);
    endwin();
    printf("\n");
}

void updatewin(WINDOW *win)
{
    wnoutrefresh( win );
    werase(inputwin);
    waddstr(inputwin,readbuffer);
    wnoutrefresh(inputwin);
    doupdate();
}

void cleandefwin(void) {
	int i;
	for (i=0; i<mhist; ++i)
		memset(defscreen[i], 0, ncolumns*sizeof(int));
	actreli=0;
	actwrli=0;
}

void updatedefwin(void) {
	int i, stan, licznik, ilosc, znak, numline, endline;
	werase(defwin);
	ilosc = 0;
	stan = 10;
	numline = actreli;
	endline = actwrli;
	while (numline != endline) {
		++ilosc;
		licznik=0;
		for (i=0; i< ncolumns; ++i) {
			znak = defscreen[numline][i];
			if (znak == '\0') break;
			if ((znak/1000) != stan) {
				if ((znak/1000) > 10)
			wattrset(defwin, COLOR_PAIR((znak/1000)%10) | A_BOLD);
				else
			wattrset(defwin, COLOR_PAIR(znak/1000));
			}
		wprintw(defwin, "%c", (defscreen[numline][i]%1000));
		}
		wprintw(defwin, "\n");
		++numline;
		if (numline == mhist) numline = 0;
		if (ilosc == nlines) break;
	}
    wnoutrefresh( defwin );
    werase(inputwin);
    waddstr(inputwin,readbuffer);
    wnoutrefresh(inputwin);
    doupdate();
}

void updateall(void)
{
    wnoutrefresh( headwin );
    wnoutrefresh( defwin );
    wnoutrefresh( userwin );
    wnoutrefresh( split1win );
    wnoutrefresh( split2win );
    wnoutrefresh( split3win );
    wnoutrefresh( split4win );
    wnoutrefresh( timewin );
    wnoutrefresh( inputwin );
    doupdate();
}

char *atime( int o )
{
    static char tt[ 9 ];
    static time_t now;
    static struct tm *tm;
    time( &now );
    tm = localtime( &now );
    strftime( tt, 9, "%H:%M:%S", tm );
    return tt;
}

char *adate(void)
{
    static char tt[ 12 ];
    static time_t now;
    static struct tm *tm;
    time( &now );
    tm = localtime( &now );
    strftime( tt, 12, "%d-%b-%Y", tm );
    return tt;
}

int auser( char *fuser )
{
    int num;
    for ( num = 0; num < 255; num++ )  if ( strcmp( users[ num ].nick, fuser ) == 0 ) return( num );
    return - 1;
}

void use_exit( int sig )
{
    pthread_kill(first, SIGKILL);
    pthread_kill(second, SIGKILL);
    cleanup();
    signal( SIGINT, use_exit );
}


int checkstr( char *ndata, char *nfuser )
{
    int i;
    char data[ 4096 ], fuser[ 20 ];
    strncpy( data, ndata, 4095 ); data[4095]='\0';
    strncpy( fuser, nfuser, 19 ); fuser[19]='\0';
    for ( i = 0; i <= strlen( data ); i++ ) data[ i ] = tolower( data[ i ] );
    for ( i = 0; i <= strlen( fuser ); i++ ) fuser[ i ] = tolower( fuser[ i ] );
    if ( strstr( data, fuser ) == 0 ) return 0;
    else return - 1;
}

void mcrypt( char *data, int cSender, int cDest, unsigned char* xVal) 
{

    unsigned int qe, qq;
    int x, stan;
    char znak;
    
    qq = strlen( data );
    send_size = qq + 4;

    for (x = 0; x < 256; ++x) {
	    stan = 1;
	    for ( qe = 0; qe < qq; qe++ ) {
		    znak = data[ qe ];
	        if ( znak != 0 ){
	             znak = ( char ) znak + ( 20-x );
	             znak = 255 - znak;
	             znak = ( char ) ( znak + cSender + cDest );
		     if (znak == '\0') stan = 0;
		}
	    }
	    if (stan) break;
    }
    
    *xVal = (char) x;
    
    for ( qe = 0; qe < qq; qe++ ) 
        if ( data[ qe ] != 0 ){
             data[ qe ] = ( char ) data[ qe ] + ( 20-x );
             data[ qe ] = 255-data[ qe ];
             data[ qe ] = ( char ) ( data[ qe ] + cSender + cDest );
	}
    data[ qe + 1 ] = 'L';
    data[ qe + 2 ] = 'C';
    data[ qe + 3 ] = '4';
    data[ qe + 4 ] = '0';
}

void decrypt( int x, char *data, int cSender, int cDest ) 
{
    unsigned int qe, qq;

    qq = strlen( data );
    for ( qe = 0; qe < qq; qe++ ) 
	if ( data[ qe ] != 0 ){
	    data[ qe ] = ( char ) ( data[ qe ] - cSender - cDest );
            data[ qe ] = 255-data[ qe ];
            data[ qe ] = ( char ) ( data[ qe ] - 20 + x );
	}
}

void make_userlist( void )
{
    unsigned int i, j = 2;
    werase( userwin );
    wattrset( userwin, COLOR_PAIR( 5 ) | A_BOLD );
    waddstr( userwin, " ONLINE  LIST:\n\n" );
    for ( i = 0; i < 255; i++ ){
        if ( strlen( users[ i ].nick ) > 0 ){
            if ( users[ i ].away != 1 )
		wattrset( userwin, COLOR_PAIR( 4 ) | A_BOLD );
            else
		wattrset( userwin, COLOR_PAIR( 4 ) );
    	    mvwaddstr( userwin, j, 0, users[ i ].nick );
    	    wattrset( userwin, COLOR_PAIR( 4 ) );
    	    if ( users[ i ].away == 1 ) {
     mvwaddstr( userwin, j, 12, " (A)" ); /* less than 20 symbols for nick!!! */
    	    }
    	    if ( users[ i ].writing == 1 ) {
     mvwaddstr( userwin, j, 12, "*" ); /* less than 20 symbols for nick!!! */
	    }
    	    j++;
	}
    }
    updatewin( userwin );
}

void decr( void )
{
    decrypt( hrcv.xVal, hrcv.data, hrcv.sender, hrcv.dest );
    hrcv.data[ strlen( hrcv.data ) - 2 ] = '\0';
}

void sline( void )
{
	writetodef(hrcv.data, 5);
	writetodef("\n", 5);
	updatedefwin();
}

void flog( char* a )
{
	if (writeus) {
		pthread_mutex_lock( &writemutex);
    chdir( "./logs" );
    f = fopen( adate(), "a" );
    if (f) {
    fwrite( a, strlen( a ), 1, f );
    fclose( f );
    fflush( NULL );
    }
		pthread_mutex_unlock( &writemutex);
	}
}

void logtime(void)
{
    static char timestr[12];
    strcpy(timestr, "[");
    strcat(timestr, atime(0));
    strcat(timestr,"] ");
    flog(timestr);
}

void showtime(int col)
{
    static char timest[12];
    strcpy(timest, "[");
    strcat(timest, atime(0));
    strcat(timest,"]");
    writetodef(timest, col);
    writetodef(" ", col);
}

void show_normal( void )
{
    int ncolor, who;
	
    if(hrcv.sender==hsnd.sender)
	ncolor = 3;
    else
	ncolor = 4;

    decr();

    pthread_mutex_lock( &defmutex);

    showtime(ncolor);
    writetodef("<", (ncolor+10) ); 

    if ( checkstr( hrcv.data, users[ hsnd.sender ].nick ) == 0 )
	    who = 5;
    else
	    who = 18;

    writetodef(hrcv.nick, who);
    writetodef("> ", (ncolor+10) ); 

    sline();
    pthread_mutex_unlock( &defmutex);

    logtime();
    flog( "<" );
    flog( hrcv.nick );
    flog( ">\t" );
    flog( hrcv.data );
    flog( "\n" );
}

void show_status( void )
{
    unsigned int i = 0;
    char tab[2];
    tab[1]='\0';
    decr();

    tab[0] = '0';
    while( tab[0] != '7' && i < 4000) {
	    if (hrcv.data[i]=='\x07') ++tab[0];
	    ++i;
    }
    if (tab[0] != '7') return;

    i = 0;

    pthread_mutex_lock( &defmutex);
    writetodef("* ", 5);
    writetodef("Nick: ", 15);
    while ( hrcv.data[ i ] != '\x07' ) {
	    tab[0] = hrcv.data[i];
	    writetodef(tab, 5);
        i++;
    }
    i++;
    writetodef(" Address: ", 15);
    while ( hrcv.data[ i ] != '\x07' ) {
	    tab[0] = hrcv.data[i];
	    writetodef(tab, 5);
        i++;
    }
    i++;
    writetodef(" IP=", 15);
    while ( hrcv.data[ i ] != '\x07' ) {
	    tab[0] = hrcv.data[i];
	    writetodef(tab, 5);
        i++;
    }
    i++;
	    writetodef("\n", 5);
	    writetodef("Using: ", 15);
    while ( hrcv.data[ i ] != '\x07' ) {
	    tab[0] = hrcv.data[i];
	    writetodef(tab, 5);
        i++;
    }
    i++;
    writetodef(" Under: ", 15);
    while ( hrcv.data[ i ] != '\x07' ) {
	    tab[0] = hrcv.data[i];
	    writetodef(tab, 5);
        i++;
    }
    i++;

    writetodef(" User is: ", 15);
    if ( hrcv.data[ i ] == '0' ) 
	    writetodef("alive", 5);
    else 
	    writetodef("away", 5);
    i = i + 2;
    writetodef(" Present: ", 15);
    while ( hrcv.data[ i ] != '\x07' ) {
	    tab[0] = hrcv.data[i];
	    writetodef(tab, 5);
        i++;
    }
    i++;
    writetodef("\n", 5);
    updatedefwin();
    pthread_mutex_unlock( &defmutex);
}

void show_me( void )
{
    pthread_mutex_lock( &defmutex);
    if ( hrcv.dest != LC_BROADCAST ) {
	    writetodef("msg", 7);
	    writetodef("(", 4);
	    writetodef(hrcv.nick, 5);
	    writetodef(") ", 4);
    }
    writetodef("* ", 16);
    writetodef(hrcv.nick, 16);
    writetodef(" ", 16);
    decr();
    sline();
    pthread_mutex_unlock( &defmutex);

    if ( hrcv.dest == LC_BROADCAST ) {
	logtime();
        flog( "* " );
        flog( hrcv.nick );
        flog( " " );
        flog( hrcv.data );
        flog( "\n" );
    }
}

void show_away( void )
{
    pthread_mutex_lock( &defmutex);
    showtime(12);
    writetodef("* ", 12);
    writetodef(hrcv.nick, 14);
    writetodef(" ", 14);
    writetodef("is away: ", 12);
    decr();
    sline();
    pthread_mutex_unlock( &defmutex);
}

void show_pop( void )
{
    pthread_mutex_lock( &defmutex);
    showtime(12);
    writetodef("Popup from ", 12);
    writetodef(hrcv.nick, 14);
    writetodef(": ", 14);
    decr();
    sline();
    beep();
    pthread_mutex_unlock( &defmutex);
    
    logtime();
    flog("Popup from ");
    flog(hrcv.nick);
    flog(": ");
    flog(hrcv.data);
    flog( "\n" );
	
}

void show_msg( void )
{
    pthread_mutex_lock( &defmutex);
    showtime(7);
    writetodef("msg", 7);
    writetodef("(", 4);
    writetodef(hrcv.nick, 5);
    writetodef(") ", 4);
    decr();
    sline();
    pthread_mutex_unlock( &defmutex);

    logtime();
    flog("PrivMsg from ");
    flog(hrcv.nick);
    flog(": ");
    flog(hrcv.data);
    flog( "\n" );
}

void show_join( void )
{
    pthread_mutex_lock( &defmutex);
	writetodef("* joins ", 12);
	writetodef(hrcv.nick, 14);
	writetodef(" ", 12);
    decr();
    writetodef(hrcv.data, 14);
    writetodef(" at ", 12);
    writetodef(atime(0), 14);
    writetodef(".\n", 12);
    updatedefwin();
    pthread_mutex_unlock( &defmutex);

    logtime();
    flog( "* joins ");
    flog( hrcv.nick );
    flog( " " );
    flog( hrcv.data );
    flog( "\n" );
}

void change_topic( void )
{
    werase( headwin );
    decr();
    if ( !strcmp( hrcv.data, "<>" ) ) {
        wattrset( headwin, A_BOLD );
        wprintw( headwin, "LANChat v%s by melun, Antoby & jeremian", VER );
    }
    else {
        wattrset( headwin, A_BOLD );
        waddstr( headwin, "LANChat: " );
        wattrset( headwin, A_NORMAL );
        waddstr( headwin, hrcv.data );

    }
    if ( hrcv.type == LC_NEWTOPIC ) {
    pthread_mutex_lock( &defmutex);
    showtime(12);
    writetodef("* ", 12);
    writetodef(hrcv.nick, 14);
    writetodef(" changed topic to: ", 12);
    writetodef(hrcv.data, 14);
    writetodef("\n", 14);
    updatedefwin();
    pthread_mutex_unlock( &defmutex);
    }
    strncpy( topic, hrcv.data, 74); topic[74]='\0';
    wnoutrefresh( headwin );

    logtime();
    flog("* ");
    flog(hrcv.nick);
    flog(" changes topic to: ");
    flog(hrcv.data);
    flog( "\n" );
}

void show_leave( void )
{
    pthread_mutex_lock( &defmutex);
	writetodef("* quits ", 12);
	writetodef(hrcv.nick, 14);
	writetodef(" at ", 12);
	writetodef(atime(0), 14);
	writetodef(".\n", 12);
	updatedefwin();
    pthread_mutex_unlock( &defmutex);

    if ( hrcv.sender != hsnd.sender ) {
        logtime();
	flog( "* quits ");
        flog( hrcv.nick );
        flog( "\n" );
    }
}

void show_stats( void )  /* Eh, statistics should be better... */
{
	char mesg[20];
    pthread_mutex_lock( &defmutex);
	writetodef("LANChat Session Statistics:\n", 5);
    if ( !cmp( topic, "<>" ) ) 
	    writetodef("topic: there is no topic\n", 5);
    else {
	    writetodef("topic: ", 5);
	    writetodef(topic, 5);
	    writetodef("\n", 5);
	    writetodef("since: ", 5);
	    writetodef(topictime, 5);
	    writetodef("\n", 5);
    }

    writetodef("Bytes received: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d\t", bytes_rcv);
    writetodef(mesg, 5);
    
    writetodef("Bytes send: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d", bytes_snd);
    writetodef(mesg, 5);

    writetodef("\n", 5);

    writetodef("Nrm received: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d\t", nor_rcv);
    writetodef(mesg, 5);

    writetodef("Msg received: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d\t", msg_rcv);
    writetodef(mesg, 5);

    writetodef("Pop-ups received: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d", pop_rcv);
    writetodef(mesg, 5);

    writetodef("\n", 5);
    
    writetodef("Nrm sended: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d\t", nor_snd);
    writetodef(mesg, 5);

    writetodef("Msg sended: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d\t", msg_snd);
    writetodef(mesg, 5);

    writetodef("Pop-ups sended: ", 5);
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d", pop_snd);
    writetodef(mesg, 5);

    writetodef("\n", 5);
    
    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d", total_msg);
    writetodef(mesg, 5);
    writetodef(" packets received.\t", 5);

    memset(mesg, 0, 20);
    snprintf(mesg, 20, "%d", total_snd);
    writetodef(mesg, 5);
    writetodef(" packets sended.\n", 5);
    
    updatedefwin();
    pthread_mutex_unlock( &defmutex);
}

void show_help( void )
{

    pthread_mutex_lock( &defmutex);
    writetodef("--------==LANChat Commands Summary==-------\n", 5);
 writetodef("/away <reason> - marks you as \"away\"\n" , 5);
 writetodef("/back - returns from \"away\" mode\n", 5);
 writetodef("/whois nickname - shows information about nick specified\n" , 5);
 writetodef("/topic <newtopic> - changes the topic\n" , 5);
 writetodef("/sa - show users away reasons\n" , 5);
 writetodef("/status - show some usage statistics\n" , 5);
 writetodef("/msg <nickname>, <body> - sends a private message\n" , 5);
 writetodef("/pop <nickname>, <body> - sends a pop-message\n" , 5);
 writetodef("/p <on|off> - turn on|off receiving pop-messages\n" , 5);
 writetodef("/l <on|off> - turn on|off logging to a file\n" , 5);
 writetodef("/nick <new-nick> - changes your nickname\n" , 5);
 writetodef("/me <body> - send a description of what you're doing\n" , 5);
 writetodef("/clear or /cls - clears screen\n" , 5);
 writetodef("/mother - clears screen and sends mother-attack message\n" , 5);
 writetodef("/credits - show some credits\n" , 5);
 writetodef("/features - show some features of lanchat\n" , 5);
 writetodef("/help - what this can be...\n" , 5);
 writetodef("/quit - close LANChat session\n" , 5);
/*writetodef("For more information about each command refer to README file\n",5);*/

updatedefwin();
    pthread_mutex_unlock( &defmutex);
}


void show_features( void )
{
    pthread_mutex_lock( &defmutex);
writetodef("LANChat features:\n", 5);
writetodef("up | down - scrolling the command history\n",5);
writetodef("pageup | pagedown - scrolling the messages window\n",5);
writetodef("tab - auto-filling commands and users names\n",5);

updatedefwin();
    pthread_mutex_unlock( &defmutex);
} 

void show_credits( void )
{
    pthread_mutex_lock( &defmutex);
 writetodef("LANChat Credits:\n", 5);
 writetodef("Linux LANChat by Mateusz Skoczewski melun <melun@xox.pl>.\n" , 5);
writetodef("Lots of bugfixes & improvements by Antoby <antoby@mail.com>.\n",5);
 writetodef("Thanks to GORO for network and process code support.\n" , 5);
 writetodef("Greets to ABGC network, AJC network, Mi-V, BLADE, [:-{\n" , 5);
 writetodef("Thanks to all beta-testers and bug notifiers.\n" , 5);
 writetodef("Send your comments to melun@xox.pl\n" , 5);
 writetodef("Visit http://lanchat.republika.pl\n" , 5);
writetodef("Some modifications by jeremian <jeremian@poczta.fm>\n" , 5);
 writetodef("Enjoy !\n" , 5);

	updatedefwin();
    pthread_mutex_unlock( &defmutex);
}

void show_resurrected( void )
{
    pthread_mutex_lock( &defmutex);
	writetodef("* ", 12);
	writetodef(hrcv.nick, 14);
	writetodef(" resurrected at ", 12);
	writetodef(atime(0), 14);
	writetodef(".\n", 12);
	updatedefwin();
    pthread_mutex_unlock( &defmutex);
}

void show_unknown( void )
{
    pthread_mutex_lock( &defmutex);
	writetodef("Unknown command: ", 12);
	writetodef(hhlp.data, 14);
	writetodef(" or command requires parameters\n", 12);
	updatedefwin();
    pthread_mutex_unlock( &defmutex);
}

void show_went_away( void )
{
    pthread_mutex_lock( &defmutex);
	writetodef("* ", 12);
	writetodef(hrcv.nick, 14);
	writetodef(" went away at ", 12);
	writetodef(atime(0), 14);
	writetodef(": ", 12);
    decr();
    sline();
    pthread_mutex_unlock( &defmutex);

    if ( hrcv.sender == hsnd.sender ) {
        snprintf( away, 249, "%s (%s)", hrcv.data, atime( 0 ) );
	away[249]='\0';
    }
    logtime();
    flog( "* ");
    flog( hrcv.nick );
    flog( " went away: " );
    flog( hrcv.data );
    flog( "\n" );
}

void show_back_away( void )
{
    pthread_mutex_lock( &defmutex);
	writetodef("* ", 12);
	writetodef(hrcv.nick, 14);
	writetodef(" came back at ", 12);
	writetodef(atime(0), 14);
	writetodef("!\n", 12);
	updatedefwin();
    pthread_mutex_unlock( &defmutex);

    logtime();
    flog( "* ");
    flog( hrcv.nick );
    flog( " came back!\n" );
}

int prepare_message( void )
{
    int i, nl = -1, nk = 0, np = 0;
    char tnick[ 20 ];

    for (i=0; i<20; i++)
	if ( hhlp.data[ i ] == ',' ){
    	    if ( np == 0 )
		nk = i;
    	    np = 1;
	}
    np = 0;
    if ( nk != 0 ) {
	    if (hhlp.data[nk-1] == ' ' || hhlp.data[nk-1] == '\t') {
		    --nk;
		    np = 1;
	    }
        strncpy( tnick, hhlp.data, nk );
        tnick[ nk ] = '\0';
        for ( i = 0; i < 255; i++ )
            if(!strcmp( users[ i ].nick, tnick))
		nl = i;
        if (nl == -1){
    pthread_mutex_lock( &defmutex);
		writetodef("error: user \"", 12);
		writetodef(tnick, 14);
		writetodef("\" not found.\n", 12);
		updatedefwin();
    pthread_mutex_unlock( &defmutex);
        }else{
            hhlp.dest = nl;
            hhlp.data[4095]='\0';
            strncpy( hhlp.data, hhlp.data + strlen( users[ nl ].nick ) + 2 + np, strlen( hhlp.data ) - strlen( users[ nl ].nick ) + 2 + np);
        }
    }else{
    pthread_mutex_lock( &defmutex);
	    writetodef("Usage: /command <nick name>, <message>\n", 12);
	    writetodef("You have to puy ',' right after the nickname.\n", 12);
	    updatedefwin();
    pthread_mutex_unlock( &defmutex);
    }

    if ( nl == -1 ) return - 1;
    else return 0;
}

void writetodef(char* text, short color) {
  int lim = strlen(text);
  int num = 0;
  int i, in, pom, pom2, pom3;
  int zmienna = 0;
  char c;
  char lastc = 0;
	color=color*1000;
  i = backpos;
  for (in=0; in < lim; ++in) {
	  c = text[in];
	  if (i == ncolumns) {
		  if (num == 0) {
			  pom3=backpos;
			  for (pom = backpos; pom < ncolumns; ++pom) {
				  if ((line[pom]=='\n')&&(pom!=ncolumns-1)) {
			  		++actwrli;
					pom3=0;
				if (actwrli==mhist) {actwrli=0; fullheap=1;}
			  memset(defscreen[actwrli], 0, ncolumns*sizeof(int));
				  }
				  else {
				 defscreen[actwrli][pom3]=(line[pom]+color);
				 ++pom3;
				  }
			  }
			  ++actwrli;
			  if (actwrli==mhist) {actwrli=0; fullheap=1;}
			  memset(defscreen[actwrli], 0, ncolumns*sizeof(int));
			  num = 0;
			  i = 0;
		  backpos=0;
		  }
		  else {
			  pom3 = backpos;
			  for (pom = backpos; pom <= num; ++pom) {
				  if ((line[pom]=='\n')&&(pom!=ncolumns-1)) {
			  		++actwrli;
					pom3=0;
				if (actwrli==mhist) {actwrli=0; fullheap=1;}
			  memset(defscreen[actwrli], 0, ncolumns*sizeof(int));
				  }
				  else {
			  defscreen[actwrli][pom3] = (line[pom]+color);
			  ++pom3;
				  }
			  }
			  ++actwrli;
			  if (actwrli==mhist) {actwrli=0; fullheap=1;}
			  memset(defscreen[actwrli], 0, ncolumns*sizeof(int));
			  for (pom = 1; pom < ncolumns-num; ++pom)
				  line[pom-1] = line[num+pom];
			  i = pom-1;
			  num = 0;
		  backpos=0;
		  }
	  }
	  if ((c==' ' || c=='\t') && (i==0) ) {
				continue;
	  }
	  if (c == ' ') {
		  num = i;
	  }
	  if (c == '\t') {
		  c=' ';
		  for (pom = 0; pom < 3 && i < ncolumns-1; ++pom) {  
			  line[i]=c;
			  ++i;
		  }
		  num = i;
	  }
     line[i]=c;
     lastc = c;
	 ++i; 
  }
	pom3 = backpos;
for (pom = backpos; pom < i; ++pom) {
				  if ((line[pom]=='\n')&&(i!=1)) {
			  		++actwrli;
					pom3=0;
				if (actwrli==mhist) {actwrli=0; fullheap=1;}
			  memset(defscreen[actwrli], 0, ncolumns*sizeof(int));
				  }
				  else {
			  defscreen[actwrli][pom3] = (line[pom]+color);
			  ++pom3;
				  }
}
			if (line[pom-1] != '\n')
			backpos = pom;
			else
			backpos = 0;
			
			if (actwrli >= actreli) {
				actreli = actwrli-nlines;
				if (actreli<0) actreli = 0;
			}
			else {
				actreli = mhist + actwrli - nlines;
				if (actreli>mhist-1) actreli-=mhist;
			}
	
}
