/*
 
  LANChat Linux version 1.1.0 fully compatible with windows LC40
  Based on LC 4.0 specification by Piotr Kowalski <goro@vc.pl> 
  
  (c) Mateusz Skoczewski <melun@xox.pl>
  Antoby <antoby@mail.com>
  jeremian <jeremian@poczta.fm>
 
  ----------------------------------------------------------------------
  The Linux LANChat and related utilities are free software; you can
  redistribute it and/or modify it under the terms of the GNU Library
  general Public License as published by the Free Software Foundation;
  either version 2 of the License, or (at your option) any later version.
 
*/

#include "lanchat.h"

WINDOW *inputwin, *defwin, *headwin, *split1win, *split2win, *split3win, *userwin, *split4win, *timewin;

char host[ 30 ], logname[ 20 ], myip[ 16 ], present[ 11 ], away[ 250 ],
     topic[ 75 ], topictime[ 9 ], readbuffer[ 4096 ], directory[ 200 ];

unsigned int  send_size, pop_mode;
unsigned long bytes_rcv=0, total_msg=0, nor_rcv=0, msg_rcv=0, pop_rcv=0;
unsigned long bytes_snd=0, total_snd=0, nor_snd=0, msg_snd=0, pop_snd;

FILE* f;

int pom;
long int czas;
void* glpetla(void* vptr);
void* czasomierz(void* vptr);
    int ssock, rsock, error;
    fd_set readfds, testfds;
    int buf_size;
    int result, licznik=1;
    struct sockaddr_in toaddr, outaddr, oth;
    int recvn, send1, send2, send3;
    pthread_t	first, second;
    pthread_mutex_t defmutex = PTHREAD_MUTEX_INITIALIZER;
    pthread_mutex_t writemutex = PTHREAD_MUTEX_INITIALIZER;
    pthread_mutex_t sendmutex = PTHREAD_MUTEX_INITIALIZER;
    int nlines, ncolumns;
    int actwrli, actreli;
    int backpos, fullheap;
    char* line;
    char writeus;
    int chist, mhist;
    unsigned char col_r, col_g, col_b;
    char commands[18][9];

    int** defscreen;
    

/********************************* main *************************************/

int main( int argc, char **argv )
{
    int i,x;
    bool finish, option, gethost=1, usenick=0;
    int away_mode = 0;
    unsigned char addr;
    lines* head = NULL;
    lines* liptr = NULL;
    lines* tail = NULL;
    int ncomm = 0;

    int chr, helparg;
    extern char *optarg;         /* getopt variable declarations */
    extern int optind;
    extern int optopt;
    extern int opterr;

    register struct hostent *hostptr;
    struct in_addr *ptr;

    while ((chr = getopt(argc, argv, "h:")) != EOF)
    switch(chr){
	case 'h':
	    gethost=0;
	    strncpy(host, optarg, 30);
	    host[29]='\0';
	    break;
	default:
	    usage();
    };
    argc -= optind;
    argv += optind;

    if(argc==1){
        strncpy( logname, argv[0], 19 );
	logname[19]='\0';
    }else if(argc==0){
        strncpy( logname, getenv( "LOGNAME" ), 19);
	logname[19]='\0';
    } else
	usage();

    hsnd.cCrypt = CRYPT_DEFAULT;

    hsnd.cHead[ 0 ] = 'L';
    hsnd.cHead[ 1 ] = 'C';
    hsnd.cHead[ 2 ] = '4';
    hsnd.cHead[ 3 ] = '0';
    
    hsnd2.cCrypt = CRYPT_DEFAULT;

    hsnd2.cHead[ 0 ] = 'L';
    hsnd2.cHead[ 1 ] = 'C';
    hsnd2.cHead[ 2 ] = '4';
    hsnd2.cHead[ 3 ] = '0';

    hhlp.cCrypt = CRYPT_DEFAULT;

    hhlp.cHead[ 0 ] = 'L';
    hhlp.cHead[ 1 ] = 'C';
    hhlp.cHead[ 2 ] = '4';
    hhlp.cHead[ 3 ] = '0';

    /* INITIALIZATION STUFF */
    /************************/

    umask( 0 );

    printf( "Initializing LANChat...\n" );
    czas = 0;
    fullheap=0;

    if(gethost)
	gethostname( host, 30 );
    hostptr = gethostbyname( host );
    if (hostptr) {
    ptr = ( struct in_addr* ) * hostptr->h_addr_list;
    strncpy( host, hostptr->h_name, 29 ); host[29]='\0';
    strcpy( myip, inet_ntoa( *ptr ));  /* safe - 255.255.255.255 max 16 */
    addr = *( hostptr->h_addr + 3 );
    }
    else {
	    printf("Fatal error when trying to get host name...\n");
	    printf("Maybe you don't have valid record in /etc/hosts...\n");
	    exit(1);
    }

    ssock = socket( AF_INET, SOCK_DGRAM, IPPROTO_UDP );
    if ( ssock == -1 ) {
        printf( "\n\r\x1b[1;31mERROR:\x1b[m Can't initialize socket...\n\n\r" );
        exit( 1 );
    }else
	printf( "Send Socket: OK\n" );

    buf_size = 1;
    setsockopt( ssock, SOL_SOCKET, SO_BROADCAST, (char *)&buf_size, sizeof(buf_size) );
    buf_size = BUF;
    setsockopt( ssock, SOL_SOCKET, SO_SNDBUF, (char *)&buf_size, sizeof(buf_size) );

    toaddr.sin_family = AF_INET;
    toaddr.sin_port = htons( INPORT );
    toaddr.sin_addr.s_addr = INADDR_BROADCAST;

    rsock = socket( PF_INET, SOCK_DGRAM, 0 );
    if ( rsock == -1 ) {
        printf( "\n\r\x1b[1;31mERROR:\x1b[m Can't initialize socket...\n\n\r" );
        exit( 1 );
    }else
	 printf( "Receive Socket: OK\n" );

    buf_size = 1;
    setsockopt( rsock, SOL_SOCKET, SO_BROADCAST, &buf_size, sizeof( buf_size ) );
    buf_size = BUF;
    setsockopt( rsock, SOL_SOCKET, SO_RCVBUF, &buf_size, sizeof( buf_size ) );

/*        buf_size = 1;
setsockopt( rsock, SOL_SOCKET, SO_REUSEADDR, &buf_size, sizeof( buf_size ) );*/

    outaddr.sin_family = AF_INET;
    outaddr.sin_port = htons( INPORT );
    outaddr.sin_addr.s_addr = htonl( INADDR_ANY );

    if ( bind( rsock, (struct sockaddr *)(&outaddr), sizeof(struct sockaddr) ) < 0 ) {
printf("\n\r\x1b[1;31mERROR:\x1b[m Can't bind receive socket. Perhaps you're \n\r" );
printf( "trying to run lanchat twice on the same machine.\n\n" );
                exit( 1 );
            } 


    hsnd.sender = addr;
    hhlp.sender = addr;
    hsnd2.sender = addr;

    memset(commands, 0, 18*9);
    strcpy(commands[0], "away ");
    strcpy(commands[1], "back");
    strcpy(commands[2], "clear");
    strcpy(commands[3], "credits");
    strcpy(commands[4], "features");
    strcpy(commands[5], "help");
    strcpy(commands[6], "l");
    strcpy(commands[7], "me ");
    strcpy(commands[8], "mother");
    strcpy(commands[9], "msg ");
    strcpy(commands[10], "nick ");
    strcpy(commands[11], "p");
    strcpy(commands[12], "pop ");
    strcpy(commands[13], "sa");
    strcpy(commands[14], "status");
    strcpy(commands[15], "topic ");
    strcpy(commands[16], "whois ");
    strcpy(commands[17], "quit");
    
  /* reading config file */
   
    memset(directory, 0, 200);
    strncpy(directory, getenv("HOME"), 200);
    strcat(directory, "/.lanchatrc");
    f = fopen(directory, "r");

    pop_mode = 0; /* allowing popup messages is default */
    writeus = 1; /* logging messages is default */
    chist = 20; /* 20 commands in the list is default */
    mhist = 100; /* 100 lines of messages is default */
    col_r = 100; /* default value of red color */
    col_g = 50; /* deault value of green color */
    col_b = 200; /* default value of blue color */
    if (!f) {
printf("Unable to open file:%s\nUsing default configuration...\n", directory);
    }
    else {
	    /* 
	     * helparg:
	     * 0 - nothing important
	     * 1 - logname - user nick
	     * 2 - pop_mode - allowing pop-ups
	     * 3 - writeus - allowing logging to a file
	     * 4 - chist - size of command history
	     * 5 - mhist - size of messages history
	     * 6 - col_r - red color
	     * 7 - col_g - green color
	     * 8 - col_b - blue color
	     * 
	     */
	    helparg = 0;
	    printf("Reading config file...\n");
	    while ((chr=fgetc(f))!=EOF) {
		    switch (chr) {
			    case '#':
				    helparg = 0;
				    while(fgetc(f)!= '\n');
				    break;
			    case '!':
				    chr = fgetc(f);
				    switch (chr) {
					    case 'u': helparg = 1;break;
					    case 'p': helparg = 2;break;
					    case 'l': helparg = 3;break;
					    case 'c': helparg = 4;break;
					    case 'm': helparg = 5;break;
					    case 'r': helparg = 6;break;
					    case 'g': helparg = 7;break;
					    case 'b': helparg = 8;break;
				    }
				    break;
			    default:
				    switch (helparg) {
					    case 1:
						    helparg = 0;
					    memset(readbuffer,0,20);
	while((chr=fgetc(f)) != '\n' && chr!='!' && chr!='#' && helparg<19) {
		readbuffer[helparg] = chr;
		++helparg;
	}
	if (!iswithoutcomma(logname)) strcpy(logname, "badusername");
	if ((argc == 0) && (helparg > 2) &&
			iswithoutcomma(readbuffer)) strncpy(logname, readbuffer, 20);
	helparg = 0;
						    break;
					    case 2:
						    chr = fgetc(f);
						    if (chr=='1') pop_mode=1;
						    if (chr=='0') pop_mode=0;
						helparg = 0;
						    break;
					    case 3:
						    chr = fgetc(f);
						    if (chr=='1') writeus=1;
						    if (chr=='0') writeus=0;
						helparg = 0;
						    break;
					    case 4:
						    helparg = 0;
					    memset(readbuffer,0,4);
	while((chr=fgetc(f)) != '\n' && chr!='!' && chr!='#' && helparg<3) {
		readbuffer[helparg] = chr;
		++helparg;
	}
	helparg = atoi(readbuffer);
	if (helparg > 9 && helparg < 501) chist = helparg;
	helparg = 0;
						    break;
					    case 5:
						    helparg = 0;
					    memset(readbuffer,0,5);
	while((chr=fgetc(f)) != '\n' && chr!='!' && chr!='#' && helparg<4) {
		readbuffer[helparg] = chr;
		++helparg;
	}
	helparg = atoi(readbuffer);
	if (helparg > 49 && helparg < 1001) mhist = helparg;
	helparg = 0;
						    break;
					    case 6:
						    helparg = 0;
					    memset(readbuffer,0,4);
	while((chr=fgetc(f)) != '\n' && chr!='!' && chr!='#' && helparg<3) {
		readbuffer[helparg] = chr;
		++helparg;
	}
	helparg = atoi(readbuffer);
	if (helparg > 0 && helparg < 201) col_r = helparg;
	helparg = 0;
						    break;
					    case 7:
						    helparg = 0;
					    memset(readbuffer,0,4);
	while((chr=fgetc(f)) != '\n' && chr!='!' && chr!='#' && helparg<3) {
		readbuffer[helparg] = chr;
		++helparg;
	}
	helparg = atoi(readbuffer);
	if (helparg > 0 && helparg < 201) col_g = helparg;
	helparg = 0;
						    break;
					    case 8:
						    helparg = 0;
					    memset(readbuffer,0,4);
	while((chr=fgetc(f)) != '\n' && chr!='!' && chr!='#' && helparg<3) {
		readbuffer[helparg] = chr;
		++helparg;
	}
	helparg = atoi(readbuffer);
	if (helparg > 0 && helparg < 201) col_b = helparg;
	helparg = 0;
						    break;
				    }
		    }
	    }
	    fclose(f);
    }

    hsnd.nR = col_r;
    hsnd.nG = col_g;
    hsnd.nB = col_b;
    hhlp.nR = col_r;
    hhlp.nG = col_g;
    hhlp.nB = col_b;
    hsnd2.nR = col_r;
    hsnd2.nG = col_g;
    hsnd2.nB = col_b;
    
  /* end of reading config file */
    
    finish = FALSE;
    option = FALSE;
    
    strcpy( present, " 0 h 0 m" );
    strcpy( topic, "<>" );

    strcpy( hsnd.nick, logname ); /* logname is safe */
    strcpy( hhlp.nick, logname ); /* logname is safe */
    strcpy( hsnd2.nick, logname ); /* logname is safe */

pthread_create(&first, NULL, &czasomierz, NULL);

    
    /* let's rock with interface */

	pthread_mutex_lock( &defmutex);
		
    initscr();
	
    headwin   = newwin( 1,       COLS,    0,       0 );
    defwin    = newwin( LINES-4, COLS-20, 1,       0 );
    userwin   = newwin( LINES-6, 16,      1,       COLS-17 );
    split2win = newwin( LINES-4, 1,       1,       COLS-19 );
    split1win = newwin( 1,       COLS,    LINES-3, 0 );
    inputwin  = newwin( 1,       COLS,    LINES-2, 0 );
    split3win = newwin( 1,       COLS,    LINES-1, 0 );
    split4win = newwin( 1,       18,    LINES-5, COLS-18 );
    timewin   = newwin( 1,       16,    LINES-4, COLS-17 );

    nlines = LINES-4;
    ncolumns = COLS-21;
    line = calloc(1, ncolumns);
    defscreen = calloc(1, mhist * sizeof(int));
    for (i=0;i<mhist;++i)
	    defscreen[i]=calloc(1, ncolumns * sizeof(int));
			    
    scrollok( defwin, TRUE );
    scrollok( inputwin, TRUE );
    keypad( inputwin, TRUE );
    nonl();
		
    if (has_colors()){
        start_color();
        init_pair( 1, COLOR_WHITE, COLOR_BLUE );
        init_pair( 5, COLOR_WHITE, COLOR_BLACK );
        init_pair( 4, COLOR_CYAN, COLOR_BLACK );
        init_pair( 2, COLOR_BLUE, COLOR_BLACK );
        init_pair( 3, COLOR_MAGENTA, COLOR_BLACK );
        init_pair( 6, COLOR_GREEN, COLOR_BLACK );
        init_pair( 7, COLOR_RED, COLOR_BLACK );
        init_pair( 8, COLOR_YELLOW, COLOR_BLACK );
        init_pair( 9, COLOR_BLUE, COLOR_BLUE );
    }

    werase( headwin );
    werase( defwin );
    werase( userwin );
    werase( inputwin );
    werase( split1win );
    werase( split2win );
    werase( split3win );
    werase( split4win );
    werase( timewin );

    wattron( headwin, COLOR_PAIR( 1 ) );
    wbkgdset( headwin, COLOR_PAIR( 1 ) );

    wattron( split1win, COLOR_PAIR( 1 ) | A_BOLD );
    wbkgdset( split1win, COLOR_PAIR( 1 ) );

    wattron( split2win, COLOR_PAIR( 2 ) );
    wattron( split3win, COLOR_PAIR( 2 ) );
    wattron( split4win, COLOR_PAIR( 2 ) );

    /* vertical line */
    for ( i = 0; i < LINES-2; i++ ) mvwaddch( split2win, i, 0, ACS_VLINE );
    /* the lines at the bottom */
    for ( i = 0; i < COLS; i++ ) waddch( split1win, ' ' );
    for ( i = 0; i < COLS; i++ ) mvwaddch( split3win, 0, i, ACS_HLINE );
    for ( i = 0; i < 18; i++ ) mvwaddch( split4win, 0, i, ACS_HLINE );
    
    updateall();

    pthread_mutex_unlock( &defmutex);

    signal( SIGINT, use_exit );

	pthread_mutex_lock( &defmutex);
	
    wattrset( timewin, COLOR_PAIR( 4 ) );
  writetodef("Welcome to ", 4);
    writetodef("Linux LANChat v", 14);
    writetodef(VER, 14);
    writetodef("\n\n", 14);
    writetodef("melun melun@xox.pl\n", 4);
writetodef("Distributed without any warranty under GPL version 2 terms\n", 4);
    writetodef("and conditions.\n", 4);
writetodef("This program is a Linux adaptation of the original LANChat\n", 4);
    writetodef("for windows. Type ", 4);
    writetodef("/help ", 14);
    writetodef("for commands summary.\n", 4);
    writetodef("http://lanchat.republika.pl\n\n", 14);

    updatedefwin();

	pthread_mutex_unlock( &defmutex);

    pthread_create(&second, NULL, &glpetla, NULL);
    
        flog( "LANChat Session opened at: " );
        flog( atime( 0 ) );
        flog( "\n\n" );
	werase(headwin);
	wattrset(headwin, A_BOLD);
	wprintw(headwin, "LANChat v%s by melun, Antoby & jeremian", VER );
	wnoutrefresh(headwin);
        hhlp.type = LC_JOIN;
        hhlp.dest = LC_BROADCAST;
        snprintf( hhlp.data, 4092, "(%s, IP=%s)", host, myip );
	hhlp.data[4092]='\0';
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal);
	snd2();

        while ( !finish ) {
		liptr=NULL;
		memset(readbuffer, 0, 4000);
			updatewin(inputwin);
		pom = 0;
		while (pom != 4100) {
		switch(chr = wgetch(inputwin)){
			case '\r': readbuffer[pom]='\0';
				   pom=4100;
				   break;
			case KEY_UP: if (head) {
					     if (!liptr) liptr=head;
					     else if (liptr->next)
						     liptr=liptr->next;
					     strcpy(readbuffer, liptr->text);
					     pom=strlen(readbuffer);
				     }
				     chr=300;
				     break;
			case KEY_DOWN: if (liptr && liptr->prev) {
					     liptr=liptr->prev;
					     strcpy(readbuffer, liptr->text);
					     pom=strlen(readbuffer);
				       }
				       else {
					       liptr=NULL;
					       readbuffer[0]='\0';
					       pom=0;
					       }
				     chr=300;
				     break;
			case KEY_PPAGE: 
			pthread_mutex_lock( &defmutex);
				     helparg = nlines/2;
			while ((actreli!=actwrli)&&helparg) {
					--actreli;
					--helparg;
					if (actreli<0) {
						if (fullheap)
						actreli=mhist-1;
						else
						actreli=-1;
					}
			}
					++actreli;
					if (actreli==mhist) actreli=0;
					updatedefwin();
			pthread_mutex_unlock( &defmutex);
				     chr=300;
				     break;
			case KEY_NPAGE:
			pthread_mutex_lock( &defmutex);
				     if (actreli<=actwrli)
					helparg=actwrli-actreli;
					else
					helparg=mhist-actreli+actwrli;

					if (helparg>nlines) {
						helparg=helparg-nlines;
						if (helparg>nlines/2)
							helparg=nlines/2;
					}
					else
						helparg=0;
			while (helparg) {
					++actreli;
					--helparg;
					if (actreli==mhist)
					actreli=0;
			}
					updatedefwin();
			pthread_mutex_unlock( &defmutex);
				     chr=300;
				     break;
			default: if (chr>255 && chr!=263) continue;
		}
			if (chr == '\r') continue;
		if (chr != '\b' && chr != 127 && chr != 263 && chr != 300)
			readbuffer[pom] = chr;
			if (chr != 300) ++pom;
			readbuffer[pom] = '\0';
			if (readbuffer[0]=='/' && chr == '\t') {
				--pom;
				readbuffer[pom]='\0';
				findword();
			}
			if ( chr == '\b' || chr == 127 || chr == 263) {
			if (pom > 2) {
				wdelch(inputwin);
				wdelch(inputwin);
				pom-=2;
			}
			else {
				wdelch(inputwin);
				pom=0;
			}
				readbuffer[pom] = '\0';
				readbuffer[pom+1] = '\0';
				readbuffer[pom+2] = '\0';
			
			}
			if (pom) {
		if (users[ hhlp.sender ].writing == 0 && readbuffer[0] != '/') {
					hhlp.type = LC_START_WRITING;
	        			hhlp.dest = LC_BROADCAST;
					hhlp.data[0]='\0';
                			strcat( hhlp.data, "\x0d\x0a\0" );
                			mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal);
					snd2();
				}
			}
			else
				if (users[ hhlp.sender ].writing == 1) {
					hhlp.type = LC_STOP_WRITING;
	        			hhlp.dest = LC_BROADCAST;
					hhlp.data[0]='\0';
                			strcat( hhlp.data, "\x0d\x0a\0" );
                			mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal);
					snd2();
				}
				
	    pthread_mutex_lock( &defmutex);
			updatewin(inputwin);
	    pthread_mutex_unlock( &defmutex);
			if (pom == 3999) break;
			
		}
			
				if (users[ hhlp.sender ].writing == 1) {
					hhlp.type = LC_STOP_WRITING;
					hhlp.data[0]='\0';
                			strcat( hhlp.data, "\x0d\x0a\0" );
                			mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal);
					snd2();
				}

				if (!strlen(readbuffer)) continue;

	    strncpy(hhlp.data, readbuffer, 4000);
	    hhlp.data[4000]='\0';
	    if (head) {
		    ++ncomm;
		    liptr = calloc(1, sizeof(lines));
		    liptr->next=head;
		    liptr->prev=NULL;
		    head->prev=liptr;
		    liptr->text=calloc(1, strlen(readbuffer)+1);
		    strcpy(liptr->text, readbuffer);
		    head = liptr;
		    if (ncomm==chist) {
			    if (tail) {
				    free(tail->text);
				    tail=tail->prev;
				    tail->next=NULL;
				    --ncomm;
			    }
		    }
	    }
	    else {
		    ncomm=1;
		    head = calloc(1, sizeof(lines));
		    head->next=NULL;
		    head->prev=NULL;
		    head->text=calloc(1, strlen(readbuffer)+1);
		    strcpy(head->text, readbuffer);
		    tail=head;
	    }
            option = FALSE;
            hhlp.type = 0;
            hhlp.dest = hhlp.sender;

            if ( !cmp( hhlp.data, "/quit") && (hhlp.data[5]=='\0') ) {
                finish = TRUE;
		continue;
            }
            if ( !cmp( hhlp.data, "/whois " ) ) {
                option = TRUE;
                hhlp.dest = hhlp.sender;
                hhlp.type = LC_REQ_STATUS_EX;
                strncpy( hhlp.data, hhlp.data + 7, strlen( hhlp.data ) - 7 );
                hhlp.data[ strlen( hhlp.data ) - 7 ] = '\0';
                    if ( auser( hhlp.data ) != -1 ) {
                        hhlp.dest = auser( hhlp.data );
                hhlp.data[ 0 ] = '\0';
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest , &hhlp.xVal);
		        snd2();    
                    }
                    else {
			pthread_mutex_lock( &defmutex);
			    writetodef("No such user: ", 12);
			    writetodef(hhlp.data, 14);
			    writetodef("\n", 14);
			    updatedefwin();
			pthread_mutex_unlock( &defmutex);
                    }
		    continue;
            }
            if ( !cmp( hhlp.data, "/away " ) ) {
                option = TRUE;
	        hhlp.type = LC_START_AWAY;
	        hhlp.dest = LC_BROADCAST;
                strncpy( hhlp.data, hhlp.data + 6, strlen( hhlp.data ) - 6 );
                hhlp.data[ strlen( hhlp.data ) - 6 ] = '\0';
                away_mode = 1;
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		snd2();
		continue;
            }
            if ( !cmp( hhlp.data, "/back" ) ) {
                option = TRUE;
        	if ( away_mode == 1 ) {
	            hhlp.type = LC_END_AWAY;
		    hhlp.dest = LC_BROADCAST;
		    away_mode = 0;
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		snd2();
		}
		continue;
            }
            if ( !cmp( hhlp.data, "/topic " ) ) {
                option = TRUE;
                hhlp.dest = LC_BROADCAST;
                hhlp.type = LC_NEWTOPIC;
                strncpy( hhlp.data, hhlp.data + 7, strlen( hhlp.data ) - 7 );
                hhlp.data[ strlen( hhlp.data ) - 7 ] = '\0';
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
                snd2();
                hhlp.type = LC_TOPIC_TIME;
                strcpy( hhlp.data, atime( 0 ) );
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		snd2();
		continue;
            }
            if ( !cmp( hhlp.data, "/sa" ) ) {
                option = TRUE;
                hhlp.dest = LC_BROADCAST;
                hhlp.type = LC_REQ_AWAY;
                hhlp.data[ 0 ] = '\0';
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		snd2();
		continue;
            }
            if ( !cmp( hhlp.data, "/status" ) ) {
                option = TRUE;
                    show_stats();
		continue;
            }
            if ( !cmp( hhlp.data, "/features" ) ) {
                option = TRUE;
                    show_features();
		continue;
            }
            if ( !cmp( hhlp.data, "/help" ) ) {
                option = TRUE;
                    show_help();
		continue;
            }
            if ( !cmp( hhlp.data, "/credits" ) ) {
                option = TRUE;
                    show_credits();
		continue;
            }
            if ( !cmp( hhlp.data, "/msg " )) {
                option = TRUE;
                hhlp.dest = hhlp.sender;
                hhlp.type = LC_NORMAL;
                strncpy( hhlp.data, hhlp.data + 5, strlen( hhlp.data ) - 5 );
                hhlp.data[ strlen( hhlp.data ) - 5 ] = '\0';
                    if ( !prepare_message() ) {
			pthread_mutex_lock( &defmutex);
			    writetodef("msg", 7);
			    writetodef(" --> ", 14);
			    writetodef("(", 14);
			    writetodef(users[hhlp.dest].nick, 5);
			    writetodef(")   ", 4);
                        hhlp.data[ strlen( hhlp.data ) ] = '\0';
			writetodef(hhlp.data, 5);
			writetodef("\n", 5);
			updatedefwin();
			pthread_mutex_unlock( &defmutex);
                        strcat( hhlp.data, "\x0d\x0a\0" );
                        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
			++msg_snd;
		        snd2();
                        }
                    continue;
            }
            if ( !cmp( hhlp.data, "/pop " ) ) {
                option = TRUE;
                hhlp.dest = hhlp.sender;
                hhlp.type = LC_POPUP;
                strncpy( hhlp.data, hhlp.data + 5, strlen( hhlp.data ) - 5 );
                hhlp.data[ strlen( hhlp.data ) - 5 ] = '\0';
                    if ( !prepare_message() ) {
			pthread_mutex_lock( &defmutex);
			    writetodef("pop", 7);
			    writetodef(" --> ", 14);
			    writetodef("(", 4);
			    writetodef(users[hhlp.dest].nick, 5);
			    writetodef(")   ", 4);
                        hhlp.data[ strlen( hhlp.data ) ] = '\0';
			writetodef(hhlp.data, 5);
			writetodef("\n", 5);
			updatedefwin();
			pthread_mutex_unlock( &defmutex);
                        strcat( hhlp.data, "\x0d\x0a\0" );
                        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
			++pop_snd;
		        snd2();
                    }
		    continue;
            }
            if ( !cmp( hhlp.data, "/clear" ) || !cmp( hhlp.data, "/cls" )) {
                option = TRUE;
			pthread_mutex_lock( &defmutex);
		cleandefwin();
		    wnoutrefresh(userwin);
		    make_userlist();
                    updatedefwin();
			pthread_mutex_unlock( &defmutex);
		    continue;
            }
	    if( !cmp(hhlp.data, "/mother")){
		option = TRUE;
		hhlp.dest = LC_BROADCAST;
		hhlp.type = LC_MOTHER;
		hhlp.data[ 0 ] = '\0';
                        strcat( hhlp.data, "\x0d\x0a\0" );
                        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		        snd2();
		    continue;
	    }
	    if( ( !option ) && !cmp(hhlp.data, "/l")){
		    if (!cmp(hhlp.data, "/l on")) {
			pthread_mutex_lock( &defmutex);
	    writetodef("Logging to a file is now ON\n", 5);
	    updatedefwin();
			pthread_mutex_unlock( &defmutex);
			if (!writeus) {
		    writeus = 1;
			pthread_mutex_lock( &writemutex);
        flog( "Start logging to a file: " );
        flog( atime( 0 ) );
        flog( "\n\n" );
			pthread_mutex_unlock( &writemutex);
			}
		option = TRUE;
		continue;
		    }
		    else if (!cmp(hhlp.data, "/l off")) {
			pthread_mutex_lock( &defmutex);
	    writetodef("Logging to a file is now OFF\n", 5);
	    updatedefwin();
			pthread_mutex_unlock( &defmutex);
			if (writeus) {
			pthread_mutex_lock( &writemutex);
        flog( "Stop logging to a file: " );
        flog( atime( 0 ) );
        flog( "\n\n" );
		    writeus = 0;
			pthread_mutex_unlock( &writemutex);
			}
		option = TRUE;
		continue;
		    }
		    else if (hhlp.data[2]=='\0') {
			pthread_mutex_lock( &defmutex);
			    if (writeus)
		    writetodef("Logging to a file: ON\n", 5);
			    else
		    writetodef("Logging to a file: OFF\n", 5);
			    updatedefwin();
			pthread_mutex_unlock( &defmutex);
		option = TRUE;
		continue;
		    }
	    }
	    if( ( !option ) && !cmp(hhlp.data, "/p")){
		    if (!cmp(hhlp.data, "/p on")) {
			pthread_mutex_lock( &defmutex);
	    writetodef("Receiving pop-messages is now ON\n", 5);
	    updatedefwin();
			pthread_mutex_unlock( &defmutex);
		    pop_mode = 0;
		option = TRUE;
		continue;
		    }
		    else if (!cmp(hhlp.data, "/p off")) {
			pthread_mutex_lock( &defmutex);
	    writetodef("Receiving pop-messages is now OFF\n", 5);
	    updatedefwin();
			pthread_mutex_unlock( &defmutex);
		    pop_mode = 1;
		option = TRUE;
		continue;
		    }
		    else if (hhlp.data[2]=='\0') {
			pthread_mutex_lock( &defmutex);
			    if (pop_mode)
		    writetodef("Receiving pop-messages: OFF\n", 5);
			    else
		    writetodef("Receiving pop-messages: ON\n", 5);
			    updatedefwin();
			pthread_mutex_unlock( &defmutex);
		option = TRUE;
		continue;
		    }
	    }
            if ( !cmp( hhlp.data, "/me " ) ) {
                option = TRUE;
                hhlp.dest = LC_BROADCAST;
                hhlp.type = LC_ME;
                strncpy( hhlp.data, hhlp.data + 4, strlen( hhlp.data ) - 4 );
                hhlp.data[ strlen( hhlp.data ) - 4 ] = '\0';
                        strcat( hhlp.data, "\x0d\x0a\0" );
                        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		        snd2();
		continue;
            }
            if ( !cmp( hhlp.data, "/nick " ) ) {
                option = TRUE;
                hhlp.dest = LC_BROADCAST;
                hhlp.type = LC_NEWNICK;
                strncpy( hhlp.data, hhlp.data + 6, strlen( hhlp.data ) - 6 );
                hhlp.data[ strlen( hhlp.data ) - 6 ] = '\0';
                if ( ( strlen( hhlp.data ) < 3 ) || ( strlen( hhlp.data ) > 19 ) ) {
			pthread_mutex_lock( &defmutex);
		writetodef("Nick length have to be >2 and <20.\n", 12);
		updatedefwin();
			pthread_mutex_unlock( &defmutex);
		}
                else if (auser(hhlp.data)!=(-1)) {
			pthread_mutex_lock( &defmutex);
		writetodef("There cannot be two the same nicks.\n", 12);
		updatedefwin();
			pthread_mutex_unlock( &defmutex);
		}
                else if (!iswithoutcomma(hhlp.data)) {
			pthread_mutex_lock( &defmutex);
		writetodef("There cannot be commas in nick.\n", 12);
		updatedefwin();
			pthread_mutex_unlock( &defmutex);
		}
		else {
                    strncpy( hhlp.nick, hhlp.data, 19 );
		    hhlp.nick[19]='\0';
                hhlp.data[ 0 ] = '\0';
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
		snd2();
                }
		    continue;
            }
            if ( ( strlen( hhlp.data ) > 0 ) && ( !finish ) && ( !option ) ) {
		if(away_mode==1){ /* termination of away mode */
                    hhlp.type = LC_END_AWAY;
            	    hhlp.dest = LC_BROADCAST;
		    snd2();
		    away_mode = 0;
		}								
                hhlp.type = LC_NORMAL;
                hhlp.dest = LC_BROADCAST;
		if(away_mode==1)
		    away_mode=2; /* force termination of away mode */
            }

            if ( ( !option ) && !cmp( hhlp.data, "/" ) ) {
                    show_unknown();
		    continue;
            }
        strcat( hhlp.data, "\x0d\x0a\0" );
        mcrypt( hhlp.data, hhlp.sender, hhlp.dest, &hhlp.xVal );
	++nor_snd;
            snd2();
            wdeleteln( inputwin );
            wrefresh( inputwin );
        }

                hsnd.dest = LC_BROADCAST;
                hsnd.type = LC_LEAVE;
                hsnd.data[ 0 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );
                mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hhlp.xVal );
		snd();
    flog( "\nLANChat Session closed at: " );
    flog( atime( 0 ) );
    flog( "\n\n" );
    flog( "===================================\n\n" );
    savingoptions();
    pthread_kill(first, SIGTERM);
    pthread_kill(second, SIGTERM);
    cleanup();
    printf("Thanks for using lanchat...\n");
    return( 0 );
}



void* glpetla(void* vptr) {
	int i;
	signal(SIGTERM, sleeping);

        while ( 1 ) {
            buf_size = sizeof( struct sockaddr );
            recvn = recvfrom( rsock, &hrcv, BUF, 0,
		    (struct sockaddr *)&oth, (unsigned int *)&buf_size );

            if ( recvn != -1 ) {
                bytes_rcv += recvn;
                total_msg++;
            }
            /* simple packet checking */
            if ( ( hrcv.cHead[ 0 ] != 'L' ) || ( hrcv.cHead[ 1 ] != 'C' )
                    || ( hrcv.cHead[ 2 ] != '4' ) || ( hrcv.cHead[ 3 ] != '0' ) ) {
			pthread_mutex_lock( &defmutex);
    writetodef("DANGER: Strange packet was received on lanchat port.\n", 12);
    updatedefwin();
			pthread_mutex_unlock( &defmutex);
            }
            else if(users[ hrcv.sender ].lag == 3)
		show_resurrected();
            if ( hrcv.dest == hsnd.sender || hrcv.dest == LC_BROADCAST )
                switch ( hrcv.type ) {

               /*** external messagess ***/
                case LC_ADD_TO_ROOM:
                    users[ hrcv.sender ].room = 1;
                    break;
                case LC_REMOVE_FROM_ROOM:
                    users[ hrcv.sender ].room = 0;
                    break;
                case LC_TOPIC:
                case LC_NEWTOPIC:
                    change_topic();
                    break;
                case LC_TOPIC_TIME:
                    decrypt( hrcv.xVal, hrcv.data, hrcv.sender, hrcv.dest );
                    hrcv.data[ strlen( hrcv.data ) - 2 ] = '\0';
                    strncpy( topictime, hrcv.data, 8 );
                    break;
                case LC_POPOK:
                case LC_CANTPOP:
			pthread_mutex_lock( &defmutex);
                    if ( hrcv.type == LC_POPOK ) {
		    writetodef("POP-UP has beed received by ", 5);
		    writetodef(hrcv.nick, 5);
		    writetodef(".\n", 5);
		    }
                    else {
		writetodef(hrcv.nick, 5);
		    writetodef(" has popup's disabled.\n", 5);
		    }
			    updatedefwin();
			pthread_mutex_unlock( &defmutex);
                    break;
                case LC_POPUP:
                        if ( pop_mode == 0 ) {
                            hsnd.type = LC_POPOK;
                            show_pop();
                        }else
			    hsnd.type = LC_CANTPOP;
                    if ( hrcv.sender != hsnd.sender ) {
                    	hsnd.dest = hrcv.sender;
                hsnd.data[ 0 ] = '\0';
                strcat( hsnd.data, "\x0d\x0a\0" );
                mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		++pop_rcv;
		        snd();
                    }
                    break;
                case LC_MOTHER:
			pthread_mutex_lock( &defmutex);
		    writetodef(hrcv.nick, 15);
		    writetodef(" has a mother attack!\n", 5);
                    if ( hrcv.sender == hsnd.sender )
			    cleandefwin();
		    updatedefwin();
			pthread_mutex_unlock( &defmutex);
		    break;
                case LC_REQ_STATUS_EX:
                    hsnd.dest = hrcv.sender;
                    hsnd.type = LC_STATUS_EX;

		    memset(present, 0, 11);
		    if (czas == 3500000) {
			    sprintf(present, "Very long\0");
		    }
		    else
			    sprintf(present, "%d h %d m\0", czas/3600, czas/60);

snprintf( hsnd.data, 4092,"%s\x07%s@%s\x07%s\x07LANChat %s\x07%s\x07%d\x07%s\x07\0",
			     hsnd.nick, logname, host, myip, VER, OS,
                             users[ hsnd.sender ].away, present );
		    hsnd.data[4092]='\0';
                    strcat( hsnd.data, "\x0d\x0a\0" );
		    mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		    snd();
                    break;
                case LC_STATUS_EX:
                    if ( hrcv.dest == hsnd.sender )
			show_status();
                    break;
                case LC_NORMAL:
                    if ( hrcv.dest == LC_BROADCAST ) {
                        show_normal();
			++nor_rcv;
		    }
                    else {
                        show_msg();
			++msg_rcv;
		    }
                    break;
                case LC_ME:
                    show_me();
                    break;
                case LC_JOIN:
                    show_join();
                    strncpy( users[ hrcv.sender ].nick, hrcv.nick, 19 );
		    users[ hrcv.sender ].nick[19]='\0';
                    users[ hrcv.sender ].away = 0;
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    hsnd.dest = hrcv.sender;
                    if( users[ hsnd.sender ].away == 0 )
			hsnd.type = LC_ALIVE;
                    else
			hsnd.type = LC_AWAY_ALIVE;
		    hsnd.data[0]='\0';
                    strcat( hsnd.data, "\x0d\x0a\0" );
                    mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		    snd();
		    if (hrcv.sender != hsnd.sender) {
                    hsnd.type = LC_TOPIC;
                    strncpy( hsnd.data, topic, 4092 ); hsnd.data[4092]='\0';
                    strcat( hsnd.data, "\x0d\x0a\0" );
                    mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		    snd();    
                    hsnd.type = LC_TOPIC_TIME;
                    strncpy( hsnd.data, topictime, 4092 ); hsnd.data[4092]='\0';
                    strcat( hsnd.data, "\x0d\x0a\0" );
                    mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		    snd();
		    }
                    break;
                case LC_LEAVE:
                    users[ hrcv.sender ].nick[ 0 ] = '\0';
                    show_leave();
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    break;
                case LC_AWAY:
                    show_away();
                    break;
                case LC_ALIVE:
                    strncpy( users[ hrcv.sender ].nick, hrcv.nick, 19 );
		    users[ hrcv.sender ].nick[19]='\0';
                    users[ hrcv.sender ].away = 0;
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    users[ hrcv.sender ].lag = 0;
                    break;
                case LC_REQ_AWAY:
                    if ( users[ hsnd.sender ].away == 1 ) {
                        hsnd.dest = hrcv.sender;
                        hsnd.type = LC_AWAY;
                        strncpy( hsnd.data, away, 4092 ); hsnd.data[4092]='\0';
                        strcat( hsnd.data, "\x0d\x0a\0" );
                        mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		        snd();    
                    }
                    break;
                case LC_REQ_ALIVE:
                    hsnd.dest = hrcv.sender;
                    if ( users[ hsnd.sender ].away == 0 )
			hsnd.type = LC_ALIVE;
                    else
			hsnd.type = LC_AWAY_ALIVE;
		    hsnd.data[0]='\0';
                    strcat( hsnd.data, "\x0d\x0a\0" );
                    mcrypt( hsnd.data, hsnd.sender, hsnd.dest, &hsnd.xVal );
		        snd();
                    
                    break;
		    
                case LC_START_WRITING:
                    users[ hrcv.sender ].writing = 1;
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    break;
                case LC_STOP_WRITING:
                    users[ hrcv.sender ].writing = 0;
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    break;
		    
                case LC_START_AWAY:
                    users[ hrcv.sender ].away = 1;
                    show_went_away();
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    break;
                case LC_END_AWAY:
                    users[ hrcv.sender ].away = 0;
                    show_back_away();
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    break;
                case LC_AWAY_ALIVE:
                    strncpy( users[ hrcv.sender ].nick, hrcv.nick, 19 );
		    users[ hrcv.sender ].nick[19]='\0';
                    users[ hrcv.sender ].away = 1;
			pthread_mutex_lock( &defmutex);
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    users[ hrcv.sender ].lag = 0;
                    break;
                case LC_NEWNICK:
                    if ( hrcv.sender == hsnd.sender ){
			strncpy( hsnd.nick, hrcv.nick, 19 );
			hsnd.nick[19]='\0';
			strncpy( hsnd2.nick, hrcv.nick, 19 );
			hsnd2.nick[19]='\0';
		    };
			pthread_mutex_lock( &defmutex);
		    writetodef("*  ", 12);
		    writetodef(users[hrcv.sender].nick, 14);
		    writetodef(" is now known as ", 12);
		    writetodef(hrcv.nick, 14);
		    writetodef("\n", 5);

		    updatedefwin();

                    strncpy( users[ hrcv.sender ].nick, hrcv.nick, 19 );
		    users[ hrcv.sender ].nick[19]='\0';
                    make_userlist();
			pthread_mutex_unlock( &defmutex);
                    break;
                }
        }
    }
 
void* czasomierz(void* vptr) {
	int po, i;
	char timetab[12];
	signal(SIGTERM, sleeping);
        while ( 1 ) {
		for (po=0;po<5;++po){
            sleep( 1 );
	    memset(timetab,0,12);
	    strcpy(timetab, "[");
	    strcat(timetab, atime(0));
	    strcat(timetab, "]");
	    pthread_mutex_lock( &defmutex);
	    werase(timewin);
	    wprintw(timewin, "TIME: %s", timetab);
	    updatewin(timewin);
	    pthread_mutex_unlock( &defmutex);
	    
	    if (czas != 3500000)
	    ++czas;
		}
                    hsnd2.dest = LC_BROADCAST;
                   if ( users[ hsnd2.sender ].away == 0 ) hsnd2.type = LC_ALIVE;
                    else hsnd2.type = LC_AWAY_ALIVE;
		    hsnd2.data[0] = '\0';
                strcat( hsnd2.data, "\x0d\x0a\0" );
                mcrypt( hsnd2.data, hsnd2.sender, hsnd2.dest, &hsnd2.xVal );
		    snd3();
                    for ( i = 0; i < 255; i++ ) 
                     if ( strlen( users[ i ].nick ) > 0 && i != hsnd2.sender ) {
                            users[ i ].lag++;
                            if ( users[ i ].lag == 3 ) {
	pthread_mutex_lock( &defmutex);
				    writetodef(users[i].nick, 14);
				    writetodef(" timed out at ", 12);
				    writetodef(atime(0), 14);
				    writetodef(".\n", 12);

                                users[ i ].nick[ 0 ] = '\0';
                                make_userlist();
				updatedefwin();
	pthread_mutex_unlock( &defmutex);
                            }
                        }
        }
	return (NULL);
}


